﻿package
{
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.net.*;

    public class graphicsclass extends Sprite
    {
        public function init():void
        {
            //We initialise a few things
            updatebackground = true;
            tiles_rect = new Rectangle(0, 0, 16, 16);
            sprites_rect = new Rectangle(0, 0, 32, 32);
            trect = new Rectangle;
            tpoint = new Point();
            tbuffer = new BitmapData(1, 1, true);
            tl = new Point(0, 0);
            ct = new ColorTransform(0, 0, 0, 1, 255, 255, 255, 1); //Set to white
            madpoint = new Point;
            madrect = new Rectangle;

            // FONT SELECTIONS
            //
            // To modify; change the "currentfont" string below, and then change the embedded font at the end of Main.as.
            // 
            // small     -  Silkscreen Font                                                  [not fixed width]
            // tiny      -  Very small font for very low resolutions                         [not fixed width]
            // flixel    -  Nokia Mobile Phone font, used in Flixel library; funky           [not fixed width]
            // c64       -  C64 font, awesome, fixed width, 8x8                                [FIXED WIDTH]
            // terminal  -  DOS Terminal font, fixed width, 8x12                               [FIXED WIDTH]
            //
            // Auntie Pixelante fonts implemented: http://www.auntiepixelante.com/
            //
            // slanted   -  Italic font                                                        [FIXED WIDTH]
            // starperv  -  Uppercase font                                                     [FIXED WIDTH]
            // crypt     -  Crypt of Tomorrow font, very small                                 [FIXED WIDTH]
            // casual    -  Casual Encounter font, fairly big                                [not fixed width]
            currentfont = "flixel";
            fontheight = 8;
            if (currentfont == "terminal")
            {
                fontheight = 12;
            }
            if (currentfont == "casual")
            {
                fontheight = 16;
            }
            bfont_rect = new Rectangle(0, 0, 8, fontheight);

            //Scaling stuff
            bigbuffer = new BitmapData(320, 32, true, 0x000000);
            bigbufferscreen = new Bitmap(bigbuffer);
            bigbufferscreen.width = 640;
            bigbufferscreen.height = 64;
            scaleMatrix = new Matrix();

            //Textboxes!
            for (i = 0; i < 20; i++)
            {
                var t:textboxclass = new textboxclass;
                textbox.push(t);
            }
            ntextbox = 0;

            backbuffer = new BitmapData(320, 240, false, 0x000000);
            screenbuffer = new BitmapData(320, 240, false, 0x000000);
			
            temptile = new BitmapData(16, 16, false, 0x000000);
            screen = new Bitmap(screenbuffer);			
            screen.width = 320;
            screen.height = 240;
			screen.scaleX=1.5;
			screen.scaleY=1.5;
            addChild(screen);
						
			
        }

        public function RGB(red:Number, green:Number, blue:Number):Number
        {
            return (blue | (green << 8) | (red << 16))
        }

        public function createtextbox(t:String, xp:int, yp:int, r:int = 255, g:int = 255, b:int = 255):void
        {
            if (ntextbox == 0)
            {
                //If there are no active textboxes, Z=0;
                tz = 0;
                ntextbox++;
            }
            else
            {
                i = 0;
                tz = -1;
                while (i < ntextbox)
                {
                    if (!textbox[i].active)
                    {
                        tz = i;
                        i = ntextbox;
                    }
                    i++;
                }
                if (tz == -1)
                {
                    tz = ntextbox;
                    ntextbox++;
                }
            }

            if (tz < 20)
            {
                textbox[tz].clear();
                textbox[tz].line[0] = t;
                textbox[tz].xp = xp;
                if (xp == -1)
                {
                    textbox[tz].xp = 160 - (((t.length / 2) + 1) * 8);
                }
                textbox[tz].yp = yp;
                textbox[tz].initcol(r, g, b);
                textbox[tz].resize();
            }
        }

        public function textboxcleanup():void
        {
            i = ntextbox - 1;
            while (i >= 0 && !textbox[i].active)
            {
                ntextbox--;
                i--;
            }
        }

        public function textboxcenter():void
        {
            textbox[tz].centerx();
            textbox[tz].centery();
        }

        public function textboxcenterx():void
        {
            textbox[tz].centerx();
        }

        public function textboxcentery():void
        {
            textbox[tz].centery();
        }

        public function addline(t:String):void
        {
            textbox[tz].addline(t);
        }

        public function textboxtimer(t:int):void
        {
            textbox[tz].timer = t;
        }

        public function textboxremove():void
        {
            //Remove all textboxes
            for (i = 0; i < ntextbox; i++)
            {
                textbox[i].remove();
            }
        }

        public function textboxactive():void
        {
            //Remove all but the most recent textbox
            for (i = 0; i < ntextbox; i++)
            {
                if (tz != i)
                {
                    textbox[i].remove();
                }
            }
        }

        public function textboxsetmenu():void
        {
            textbox[tz].ismenu = true;
        }

        public function drawgui():void
        {
            textboxcleanup();
            //Draw all the textboxes to the screen
            for (i = 0; i < ntextbox; i++)
            {
                //This routine also updates the textboxs
                textbox[i].update();
                if (textbox[i].active)
                {
                    if (textbox[i].ismenu)
                    {
                        backbuffer.fillRect(textbox[i].textrect, RGB(textbox[i].r / 6, textbox[i].g / 6, textbox[i].b / 6));

                        for (j = 0; j < textbox[i].numlines; j++)
                        {
                            if (textbox[i].highlighted == j)
                            {
                                print(textbox[i].xp + 2, textbox[i].yp + fontheight + (j * fontheight), ">", 255 - help.glow, 255 - help.glow, 255 - help.glow);
                                print(textbox[i].xp + 8, textbox[i].yp + fontheight + (j * fontheight), textbox[i].line[j], 255 - help.glow, 255 - help.glow, 255 - help.glow);
                            }
                            else
                            {
                                print(textbox[i].xp + 8, textbox[i].yp + fontheight + (j * fontheight), textbox[i].line[j], textbox[i].r * .5, textbox[i].g * .5, textbox[i].b * .5);
                            }
                        }
                    }
                    else
                    {
                        backbuffer.fillRect(textbox[i].textrect, RGB(textbox[i].r / 6, textbox[i].g / 6, textbox[i].b / 6));

                        for (j = 0; j < textbox[i].numlines; j++)
                        {
                            print(textbox[i].xp + 8, textbox[i].yp + fontheight + (j * fontheight), textbox[i].line[j], textbox[i].r, textbox[i].g, textbox[i].b);
                        }
                    }
                }
            }
        }

        public function maketilearray():void
        {
            for (var j:Number = 0; j < 15; j++)
            {
                for (var i:Number = 0; i < 20; i++)
                {
                    var t:BitmapData = new BitmapData(16, 16, true, 0x000000);
                    var temprect:Rectangle = new Rectangle(i * 16, j * 16, 16, 16);
                    t.copyPixels(buffer, temprect, tl);
                    tiles.push(t);
                }
            }
        }

        public function settrect(x:int, y:int, w:int, h:int):void
        {
            trect.x = x;
            trect.y = y;
            trect.width = w;
            trect.height = h;
        }

        public function settpoint(x:int, y:int):void
        {
            tpoint.x = x;
            tpoint.y = y;
        }

        public function makespritearray():void
        {
            for (var j:Number = 0; j < 15; j++)
            {
                for (var i:Number = 0; i < 20; i++)
                {
                    var t:BitmapData = new BitmapData(32, 32, true, 0x000000);
                    var temprect:Rectangle = new Rectangle(i * 32, j * 32, 32, 32);
                    t.copyPixels(buffer, temprect, tl);
                    sprites.push(t);
                }
            }
        }

        public function addimage():void
        {
            var t:BitmapData = new BitmapData(buffer.width, buffer.height, true, 0x000000);
            t.copyPixels(buffer, new Rectangle(0, 0, buffer.width, buffer.height), tl);
            images.push(t);
        }

        public function addbackgroundBmp(b:Bitmap, key:int):void
        {
            var t:BitmapData = b.bitmapData;

        }

        public function drawgraph(game:gameclass, t:int):void
        {
            var top:int, bottom:int, scale:Number, p1:int, p2:int;

            top = 100;
            bottom = 235;
            scale = 75 / (game.product[t].v);
            for (i = 0; i < 30; i++)
            {
                p1 = bottom - (game.product[t].history[game.week - 29 + i - 1] - game.product[t].mid) * scale;
                p2 = bottom - (game.product[t].history[game.week - 29 + i] - game.product[t].mid) * scale;
                drawline(-5 + (i * 10), p1, 5 + (i * 10), p2, 0, 255, 0);
            }

            for (i = 0; i < 30; i++)
            {
                p1 = bottom - (game.product[t].history[game.week - 29 + i - 1] - game.product[t].mid) * scale;
                p2 = bottom - (game.product[t].history[game.week - 29 + i] - game.product[t].mid) * scale;
                if (game.product[t].active[game.week - 29 + i])
                {
                    drawbox(5 + (i * 10) - 2, p2 - 2, 4, 4, 255, 0, 0);
                }
                else
                {
                    drawbox(5 + (i * 10) - 2, p2 - 2, 4, 4, 0, 255, 0);
                }
            }

            if (game.product[t].active[game.week])
            {
                drawbox(295 - 3, p2 - 3, 6, 6, 255, 0, 0);
            }
            else
            {
                drawbox(295 - 3, p2 - 3, 6, 6, 0, 255, 0);
            }
        }

        // Draw Primatives
        public function drawline(x1:int, y1:int, x2:int, y2:int, r:int, g:int, b:int):void
        {
            //if (x1 > x2) {
            //	drawline(x2, y1, x1, y2, r, g, b);
            //}else if (y1 > y2) {
            //	drawline(x1, y2, x2, y1, r, g, b);
            //}else {
            tempshape.graphics.clear();
            tempshape.graphics.lineStyle(1, RGB(r, g, b));
            tempshape.graphics.lineTo(x2 - x1, y2 - y1);

            shapematrix.translate(x1, y1);
            backbuffer.draw(tempshape, shapematrix);
            shapematrix.translate(-x1, -y1);
            //}
        }

        public function drawbox(x1:int, y1:int, w1:int, h1:int, r:int, g:int, b:int):void
        {
            settrect(x1, y1, w1, 1);
            backbuffer.fillRect(trect, RGB(r, g, b));
            settrect(x1, y1 + h1 - 1, w1, 1);
            backbuffer.fillRect(trect, RGB(r, g, b));
            settrect(x1, y1, 1, h1);
            backbuffer.fillRect(trect, RGB(r, g, b));
            settrect(x1 + w1 - 1, y1, 1, h1);
            backbuffer.fillRect(trect, RGB(r, g, b));
        }

        public function fillrect(x1:int, y1:int, w1:int, h1:int, r:int, g:int, b:int):void
        {
            settrect(x1, y1, w1, h1);
            backbuffer.fillRect(trect, RGB(r, g, b));
        }

        // Draw Graphics
        public function drawbackground(bd:BitmapData):void
        {
            backbuffer.copyPixels(bd, backbuffer.rect, tl);
        }

        public function drawimage(t:int, xp:int, yp:int, cent:Boolean = false):void
        {
            if (cent)
            {
                backbuffer.copyPixels(images[t], new Rectangle(0, 0, images[t].width, images[t].height), new Point(80 - int(images[t].width / 2), yp));
            }
            else
            {
                backbuffer.copyPixels(images[t], new Rectangle(0, 0, images[t].width, images[t].height), new Point(xp, yp));
            }
        }

        public function drawrectparticle(game:gameclass, obj:entityclass, i:int):void
        {
            //Draw the retangle indicated by that object
            madrect.x = obj.entities[i].xp;
            madrect.y = obj.entities[i].yp;
            madrect.width = obj.entities[i].w;
            madrect.height = 2;
            backbuffer.fillRect(madrect, obj.entities[i].life);

            madrect.x = obj.entities[i].xp;
            madrect.y = obj.entities[i].yp;
            madrect.width = 2;
            madrect.height = obj.entities[i].h;
            backbuffer.fillRect(madrect, obj.entities[i].life);

            madrect.x = obj.entities[i].xp + obj.entities[i].w - 1;
            madrect.y = obj.entities[i].yp;
            madrect.width = 2;
            madrect.height = obj.entities[i].h;
            backbuffer.fillRect(madrect, obj.entities[i].life);

            madrect.x = obj.entities[i].xp;
            madrect.y = obj.entities[i].yp + obj.entities[i].h - 1;
            madrect.width = obj.entities[i].w;
            madrect.height = 2;
            backbuffer.fillRect(madrect, obj.entities[i].life);
        }

        public function drawentities(game:gameclass, obj:entityclass):void
        {
            for (i = 0; i < obj.nentity; i++)
            {
                obj.animateentities(game, i);
                if (obj.entities[i].active)
                {
                    if (obj.entities[i].size == 1)
                    {
                        if (obj.entities[i].active)
                        {
                            drawrectparticle(game, obj, i);
                        }
                    }
                    else if (obj.entities[i].size == 2)
                    {
                        if (!obj.entities[i].invis && obj.entities[i].active)
                        {
                            backbuffer.copyPixels(tiles[obj.entities[i].drawframe], tiles_rect, new Point(obj.entities[i].xp, obj.entities[i].yp));
                            backbuffer.copyPixels(tiles[obj.entities[i].drawframe + 20], tiles_rect, new Point(obj.entities[i].xp, obj.entities[i].yp + 16));
                        }
                    }
                    else
                    {
                        if (!obj.entities[i].invis)
                        {
                            backbuffer.copyPixels(tiles[obj.entities[i].drawframe], tiles_rect, new Point(obj.entities[i].xp, obj.entities[i].yp));
                        }
                    }
                }
            }

            switch (game.currentroom)
            {
                //do custom zoom here
            }
        }

        public function drawbuffertile(x:int, y:int, t:int):void
        {
            buffer.copyPixels(tiles[t], tiles_rect, new Point(x, y));
        }

        public function drawtile(x:int, y:int, t:int):void
        {
            backbuffer.copyPixels(tiles[t], tiles_rect, new Point(x, y));
        }

        public function drawsprite(x:int, y:int, t:int):void
        {
            backbuffer.copyPixels(sprites[t], sprites_rect, new Point(x, y));
        }

        public function drawmap(map:mapclass):void
        {
            for (j = 0; j < 15; j++)
            {
                for (i = 0; i < 20; i++)
                {
                    drawtile((i * 16), (j * 16), map.at(i, j));
                }
            }
        }

        //Text Functions

        public function adjustletter(t1:int, d:int = 1):void
        {
            bfontlen[t1] += d;
            bfontlen[t1 + 32] += d;
        }

        public function adjustcharacter(t1:int, d:int = 1):void
        {
            bfontlen[t1] += d;
        }

        public function makebfont():void
        {
            for (j = 0; j < 16; j++)
            {
                for (i = 0; i < 16; i++)
                {
                    tbuffer = new BitmapData(8, fontheight, true, 0x000000);
                    settrect(i * 8, j * fontheight, 8, fontheight);
                    tbuffer.copyPixels(buffer, trect, tl);
                    bfont.push(tbuffer);
                }
            }

            //Ok, now we work out the lengths 
            if (currentfont == "small")
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(6);
                }
                var maprow:Array;
                var tstring:String = "4,3,5,7,6,7,6,3,4,4,7,7,3,5,2,5,6,5,6,6,6,6,6,6,6,6,2,3,5,5,5,6,7,6,6,6,6,5,5,6,6,3,6,6,5,7,7,6,6,6,6,6,5,6,7,7,7,7,5,4,5,4,5,6,4,6,6,6,6,5,5,6,6,3,6,6,5,7,7,6,6,6,6,6,5,6,7,7,7,7,5,5,3,5,6,4";

                maprow = new Array();
                maprow = tstring.split(",");
                for (var k:int = 0; k < 96; k++)
                {
                    bfontlen[k + 32] = int(maprow[k]);
                }
            }
            else if (currentfont == "tiny")
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(4);
                }
                adjustletter("I".charCodeAt(0), -2);
                adjustletter("M".charCodeAt(0), 2);
                adjustletter("N".charCodeAt(0));
                adjustletter("W".charCodeAt(0), 2);

                adjustcharacter(" ".charCodeAt(0), -1);
                adjustcharacter(".".charCodeAt(0), -1);
                adjustcharacter(",".charCodeAt(0), -1);
                adjustcharacter(";".charCodeAt(0), -1);
                adjustcharacter(":".charCodeAt(0), -1);
                adjustcharacter("'".charCodeAt(0), -2);
                adjustcharacter("&".charCodeAt(0));
                adjustcharacter("*".charCodeAt(0), 2);
                adjustcharacter("4".charCodeAt(0));
            }
            else if (currentfont == "flixel")
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(6);
                }

                adjustletter("I".charCodeAt(0), -3);
                adjustletter("J".charCodeAt(0), -1);
                adjustletter("K".charCodeAt(0));
                adjustletter("L".charCodeAt(0), -1);
                adjustletter("M".charCodeAt(0), 2);
                adjustletter("N".charCodeAt(0));
                adjustletter("O".charCodeAt(0));
                adjustletter("Q".charCodeAt(0));
                adjustletter("S".charCodeAt(0), -1);
                adjustletter("T".charCodeAt(0));
                adjustletter("V".charCodeAt(0));
                adjustletter("W".charCodeAt(0), 2);
                adjustletter("X".charCodeAt(0));
                adjustletter("Y".charCodeAt(0));

                adjustcharacter("c".charCodeAt(0), -1);
                adjustcharacter("f".charCodeAt(0), -2);
                adjustcharacter("k".charCodeAt(0), -1);
                adjustcharacter("l".charCodeAt(0), -2);
                adjustcharacter("m".charCodeAt(0));
                adjustcharacter("n".charCodeAt(0), -1);
                adjustcharacter("o".charCodeAt(0), -1);
                adjustcharacter("q".charCodeAt(0), -1);
                adjustcharacter("r".charCodeAt(0), -1);
                adjustcharacter("t".charCodeAt(0), -3);
                adjustcharacter("v".charCodeAt(0), -1);
                adjustcharacter("x".charCodeAt(0), -1);
                adjustcharacter("y".charCodeAt(0), -1);

                adjustcharacter("'".charCodeAt(0), -4);
                adjustcharacter(".".charCodeAt(0), -2);
                adjustcharacter(",".charCodeAt(0), -2);
                adjustcharacter("&".charCodeAt(0));
                adjustcharacter(" ".charCodeAt(0), -1);
            }
            else if (currentfont == "crypt")
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(5);
                }
            }
            else if (currentfont == "starperv")
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(6);
                }
            }
            else if (currentfont == "casual")
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(8);
                }

                adjustcharacter("i".charCodeAt(0), -4);
                adjustcharacter("j".charCodeAt(0), -2);
                adjustcharacter("l".charCodeAt(0), -3);
                adjustcharacter("f".charCodeAt(0), -1);
                adjustcharacter("m".charCodeAt(0), 2);
                adjustcharacter("w".charCodeAt(0));

                adjustcharacter("'".charCodeAt(0), -4);
                adjustcharacter(".".charCodeAt(0), -2);
                adjustcharacter(",".charCodeAt(0), -2);
            }
            else
            {
                for (i = 0; i < 256; i++)
                {
                    bfontlen.push(8);
                }
            }
        }

        public function rprint(x:int, y:int, t:String, r:int, g:int, b:int):void
        {
            x = x - len(t);
            print(x, y, t, r, g, b, false);
        }

        public function print(x:int, y:int, t:String, r:int, g:int, b:int, cen:Boolean = false):void
        {
            if (r < 0)
            {
                r = 0;
            }
            if (g < 0)
            {
                g = 0;
            }
            if (b < 0)
            {
                b = 0;
            }
            if (r > 255)
            {
                r = 255;
            }
            if (g > 255)
            {
                g = 255;
            }
            if (b > 255)
            {
                b = 255;
            }
            ct.color = RGB(r, g, b);
            if (cen)
            {
                x = 160 - (len(t) / 2);
            }
            bfontpos = 0;
            for (var i:int = 0; i < t.length; i++)
            {
                cur = t.charCodeAt(i);
                bfont[cur].colorTransform(bfont_rect, ct);
                backbuffer.copyPixels(bfont[cur], bfont_rect, new Point(x + bfontpos, y));
                bfontpos += bfontlen[cur];
            }
        }

        public function rbigprint(x:int, y:int, t:String, r:int, g:int, b:int, cen:Boolean = false, sc:Number = 2):void
        {
            x = x - (len(t) * sc);
            bigprint(x, y, t, r, g, b, cen, sc);
        }

        public function printGraphic(g:BitmapData):void
        {
            backbuffer.draw(g, scaleMatrix);
        }

        public function bigprint(x:int, y:int, t:String, r:int, g:int, b:int, cen:Boolean = false, sc:Number = 2):void
        {
            if (r < 0)
            {
                r = 0;
            }
            if (g < 0)
            {
                g = 0;
            }
            if (b < 0)
            {
                b = 0;
            }
            if (r > 255)
            {
                r = 255;
            }
            if (g > 255)
            {
                g = 255;
            }
            if (b > 255)
            {
                b = 255;
            }
            ct.color = RGB(r, g, b);

            scaleMatrix.scale(sc, sc);

            bigbuffer.fillRect(bigbuffer.rect, 0x000000);
            ct.color = RGB(r, g, b);
            if (sc == 2)
            {
                if (cen)
                {
                    x = 160 - (len(t));
                }
            }
            else if (sc == 3)
            {
                if (cen)
                {
                    x = 160 - ((len(t) / 2) * 3);
                }
            }
            else if (sc == 4)
            {
                if (cen)
                {
                    x = 160 - (len(t) * 2);
                }
            }
            else
            {
                if (cen)
                {
                    x = 160 - ((len(t) / 2) * sc);
                }
            }
            bfontpos = 0;
            for (i = 0; i < t.length; i++)
            {
                cur = t.charCodeAt(i);
                bfont[cur].colorTransform(bfont_rect, ct);
                bigbuffer.copyPixels(bfont[cur], bfont_rect, new Point(bfontpos, 0));
                bfontpos += bfontlen[cur];
            }

            scaleMatrix.translate(x, y);
            backbuffer.draw(bigbufferscreen, scaleMatrix);
            scaleMatrix.identity();
        }

        public function len(t:String):int
        {
            bfontpos = 0;
            for (var i:int = 0; i < t.length; i++)
            {
                cur = t.charCodeAt(i);
                bfontpos += bfontlen[cur];
            }
            return bfontpos;
        }

        //Render functions

        public function flashlight():void
        {
            backbuffer.fillRect(backbuffer.rect, 0x8F2D2D);
        }

        public function screenshake():void
        {
            screenbuffer.lock();
            screenbuffer.copyPixels(backbuffer, backbuffer.rect, tl, null, null, false);
            screenbuffer.copyPixels(backbuffer, backbuffer.rect, new Point((Math.random() * 5) - 3, (Math.random() * 5) - 3), null, null, false);
            screenbuffer.unlock();

            backbuffer.lock();
            backbuffer.fillRect(backbuffer.rect, 0x000000);
            backbuffer.unlock();
        }

        public function normalrender():void
        {
            screenbuffer.lock();
            screenbuffer.copyPixels(backbuffer, backbuffer.rect, tl, null, null, false);
            screenbuffer.unlock();

            backbuffer.lock();
            backbuffer.fillRect(backbuffer.rect, 0x000000);
            backbuffer.unlock();
        }

        public static var zoomamount:Number = 0;

        public function render(game:gameclass):void
        {
            if (Main.zoomamount > 0)
            {
                Main.zoomShader.data.amount.value = [ Main.zoomamount ];
                this.backbuffer.applyFilter(this.backbuffer, new Rectangle(0, 0, this.backbuffer.width, this.backbuffer.height), new Point(0, 0), Main.zoomFilter);
            }

            if (game.test)
            {
                print(5, 5, game.teststring, 196, 196, 196, false);
            }

            if (game.flashlight > 0)
            {
                game.flashlight--;
                flashlight();
            }
            if (game.screenshake > 0)
            {
                game.screenshake--;
                screenshake();
            }
            else
            {
                normalrender();
            }
        }

        public var backgrounds:Array = new Array();

        public var images:Array = new Array();

        public var tiles:Array = new Array();

        public var sprites:Array = new Array();

        public var ct:ColorTransform;

        public var tiles_rect:Rectangle;

        public var sprites_rect:Rectangle;

        public var bfont_rect:Rectangle;

        public var bfontmask_rect:Rectangle;

        public var images_rect:Rectangle;

        public var tl:Point; //The point at (0,0)

        public var trect:Rectangle, tpoint:Point, tbuffer:BitmapData;

        public var i:int, j:int, k:int, l:int, tz:int;

        public var currentfont:String, fontheight:int;

        public var bfont:Array = new Array();

        public var bfontlen:Array = new Array();

        public var bfontpos:int;

        public var cur:int;

        public var temp:int;

        public var temp2:int;

        public var temp3:int;

        public var alphamult:uint;

        public var stemp:String;

        public var buffer:BitmapData;

        public var temptile:BitmapData;

        //Actual backgrounds
        public var backbuffer:BitmapData;

        public var screenbuffer:BitmapData;

        public var screen:Bitmap;

        public var updatebackground:Boolean;

        //Textbox Stuff
        public var ntextbox:int;

        public var textbox:Array = new Array;

        //Sprite Scaling Stuff
        public var bigbuffer:BitmapData;

        public var bigbufferscreen:Bitmap;

        public var scaleMatrix:Matrix = new Matrix();

        //Tempshape
        public var tempshape:Shape = new Shape();

        public var shapematrix:Matrix = new Matrix();

        public var madrect:Rectangle, madpoint:Point;
    }
}